import sys, os, re, math
from scipy.special import *

rgx_PathTrailer = re.compile ('_[0-9]*$')


#										
def summary (_lstValues):
	iCount = len (_lstValues)
	fSum = sum (map (lambda x: 1 if x > 0 else 0, _lstValues))
	fSumLoss = sum (map (lambda x: 1 if x < 0 else 0,  _lstValues))
	fAvg = 0
	fAvgLoss = 0
	if 0 != iCount:
		fAvg = 1.0 * fSum / iCount
		fAvgLoss = 1.0 * fSumLoss / iCount
		fQ = math.sqrt (1.0 * fAvg * (1 - fAvg) / iCount)
		fQ5 = 1.96 * math.sqrt (1.0 * fAvg * (1 - fAvg) / iCount)
		fQ10 = 1.64 * math.sqrt (1.0 * fAvg * (1 - fAvg) / iCount)

	#return (fAvg-fQ5, fAvg-fQ10, fAvg, fAvg+fQ10, fAvg+fQ5)
	#return (fAvg, fAvgLoss, fQ10, fQ5)
	return (fAvg, fAvgLoss)


#										
def eval_world_control (_sFileName):
	iPlayer0 = 0
	iPlayer1 = 0
	file = open (_sFileName)
	for sLine in file:
		if False == sLine.startswith ('owner'):
			continue
		lstValues = sLine.split ('=')[-1].replace ('"', '').split (',')
		iPlayer0 += len (filter (lambda x: '0' == x, lstValues))
		iPlayer1 += len (filter (lambda x: '1' == x, lstValues))
	file.close ()

	return 1.0 * iPlayer0 / (iPlayer0 + iPlayer1)


#										
def game_won_lost (_sFileName):
	file = open (_sFileName)
	bEndSeen = False
	sLast = ''
	for sLine in file:
		if ('score (1000,' in sLine):
			iStep = int (sLine.split ('/', 1)[0].replace ('step ', ''))
			return (1, iStep)
		if 'score (0,' in sLine:
			return (-1, 100)
		if 'step ' in sLine:
			(a, b) = sLine.split (',', 1)[0].replace ('step ', '').split ('/')
			if a == b:
				bEndSeen = True
		if 'step 100/100,' in sLine:
			bEndSeen = True
		if 'step ' in sLine:
			sLast = sLine

	if True == bEndSeen:
		return (0, -1)
	else:
		#print sLast
		#print _sFileName
		return (-2, -2)


#										
def main ():
	# mapShortNameTranslation = {"bg":"g", "bi":"i", "bt2":"t", "btp":"tp"}

	lstPaths = sys.argv [1:]
	mapScores = {}
	mapWins = {}
	mapPartWins = {}
	for sPath in lstPaths:
		if True == os.path.isfile (sPath):
			continue
		if False == os.path.exists (sPath + '/run.log'):
			continue
		sShortName = rgx_PathTrailer.sub ('', sPath.rsplit ('/', 1)[-1])
		# sShortName = mapShortNameTranslation.get (sShortName, sShortName)

		(fWin, iEndStep) = game_won_lost (sPath + '/run.log')
		if -2 == fWin:
			# print sPath
			continue
		if None == mapWins.get (sShortName, None):
			mapWins [sShortName] = []
		mapWins [sShortName].append (fWin)
		if (0 != fWin) and (1 != fWin):
			if None == mapPartWins.get (sShortName, None):
				mapPartWins [sShortName] = []
			mapPartWins [sShortName].append (fWin)

	
	lstK = mapWins.keys ()
	lstK.sort ()
	for k in lstK:
		w = mapWins [k]
		print  ''.join ([' '] * (15-len(k))) + k + '   %0.4f   %0.4f' % summary (w) + '   %d'%len(w)



if __name__ == '__main__':
	sys.exit (main ())
