import sys, os, random
from misc import *


def scramble_text (_lstText):
	for i, sLine in enumerate (_lstText):
		lstWords = sLine.split ()
		random.shuffle (lstWords)
		random.shuffle (lstWords)
		random.shuffle (lstWords)
		_lstText [i] = ' '.join (lstWords)

	return _lstText


def match_dep_to_text (_lstDep, _lstText):
	for i, (sDep, sText) in enumerate (zip (_lstDep, _lstText)):
		lstD = sDep.split ('\x02')
		lstW = sText.split ()

		for j, d in enumerate (lstD):
			(sType, sFromIndex, sFromWord, sFromTag, sToWord, sToTag, sLeaf) = d.split ('\x01')
			sFromWord = lstW [int (sFromIndex)]
			sToWord = lstW [j]

			lstD [j] = sType + '\x01' +\
					   sFromIndex + '\x01' +\
					   sFromWord + '\x01' +\
					   sFromTag + '\x01' +\
					   sToWord + '\x01' +\
					   sToTag + '\x01' +\
					   sLeaf

		_lstDep [i] = '\x02'.join (lstD)

	return _lstDep


def main ():
	sText = sys.argv [1]
	sDep = sys.argv [2]
	sOutput = sys.argv [3]

	lstText = std_read_file (sText)
	lstDep = std_read_file (sDep)[1:]

	lstText = scramble_text (lstText)
	lstDep = match_dep_to_text (lstDep, lstText)

	file = open (sOutput + '.text', 'w')
	file.write ('\n'.join (lstText))
	file.close ()

	file = open (sOutput + '.dep', 'w')
	file.write ('#[dependency type]\x01[from index]\x01[from word]\x01[from tag]\x01[to word]\x01[to tag]\n')
	file.write ('\n'.join (lstDep))
	file.close ()



if __name__ == '__main__':
	sys.exit (main ())

